{-
Author:  Christian Sternagel <c.sternagel@gmail.com> (2011-2015)
Author:  René Thiemann <rene.thiemann@uibk.ac.at> (2011)
License: LGPL (see file COPYING.LESSER)
-}
module Main(main) where 

import Tree_Automata_Checker; -- the certifier
import System; -- for getArgs
import System.IO; -- for file reading

main = do args <- getArgs
          case length args of
            1 -> do problemString <- readFile (args !! 0)
                    start problemString
            _ -> do error "usage: cetaa problemFile.xml"

start problemString = 
    do case certify_proof False problemString of
         Certified -> putStr ("CERTIFIED\n")
         Unsupported message -> 
             do putStrLn "UNSUPPORTED" 
                error (message ++ "\n")
         Reject message -> 
             do putStrLn "REJECTED"
                error (message ++ "\n")

