/*
Author:  Christian Sternagel <c.sternagel@gmail.com> (2011-2015)
Author:  René Thiemann <rene.thiemann@uibk.ac.at> (2011, 2012)
License: LGPL (see file COPYING.LESSER)
*/
import scala.io.Source
import Ceta._

object Main {
  def main(args : Array[String]) {
    if (args.length == 1) {
      start(false, Source.fromFile(args(0)).toList)
    } else if (args.length == 2) {
      if (args(0) == "--allow-assumptions")
        start(true, Source.fromFile(args(1)).toList)
        else error("flag '" + args(0) + "' not supported")
    } else {
      error("usage: ceta [--allow-assumptions] problemFile.xml(in cpf-format)     (CeTA version 2.xx)")
    }
  }

  def start(a : Boolean, input : List[Char]) = certify_proof(a, input) match {
    case Sumbot(Inr(Certified(prf))) => print("CERTIFIED " + prf.mkString + "\n")
    case Sumbot(Inr(Unsupported(msg))) => error("UNSUPPORTED\n" + msg.mkString + "\n")
    case Sumbot(Inr(Error(msg))) => error("REJECTED\n" + msg.mkString + "\n")
    case Sumbot(Inl(msg)) => error("UNKNOWN ERROR\n" + msg.mkString + "\n")
  }
}
